/************************************************************************
 *	CarbonCopies							*
 *	errorlevel =	0 -   		*
 *			1 -						*
 *			2 -   			*
 *			3 -   				*
 *			4 -    ()		*
 ************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>
#include <time.h>
#include <sys/wait.h>
#include <sys/resource.h>
#include <sys/types.h>
#include <locale.h>
#include "carboncopies.h"

#define MAX	766		// name[255] + emailpath[255] + 1
#define MMAX	256		// MAX/2
#define	MAXEMAIL	75	//   e-mail .

#define	FROM	"From: "		// cc = 0
#define	TO0	"X-Comment-To: "	// cc = 1
#define	TO1	"To: "			// cc = 1
#define	SUBJ	"Subject: "		// cc = 2
					// cc = 3

struct CONF {
	int num;		//  0:   'email-path'  e-mail.
	int cc;
	char name[MMAX+1];
	char emailnewsgroup[MMAX+1];
} conf[MAXCC];

static int RMAXCC = 0;

int main()
{
	int c, i, num;
	char cctmp[MMAX];
	char path[MMAX];
	char prog[MMAX];
	char buf[MMAX];
	FILE *f;

	//       - /path/cc.tmp.<PID>
	sprintf( cctmp, "%s.%d.%d", CCTMP, time( NULL ), getpid() );
	//          
	if( ( f = fopen( cctmp, "w" ) ) == NULL ) exit( 2 );
	while( ( c = getchar () ) != EOF )
		putc( c, f );
	fclose( f );

	readconf();
	i = xcommentto( cctmp );
	if( i != -1 )
	{
		if( conf[i].num == 0 )
		{
			sendemail( cctmp, i );
			remove( cctmp );
			remove( LOCK );
			exit( 0 );
		}
		//      - /spool/number
		num = number ( conf[i].num );
		//   '.'  '/'
		strcpy( buf, conf[i].emailnewsgroup ); c = 0;
		while( buf[c] != 0 ) if ( buf[c++] == '.' ) buf[c-1] = '/';
		sprintf( path, "%s/%s/%d", SPOOL, buf, num );
		rename( cctmp, path );	//    spool
		sprintf(prog, "%s %s >/dev/null", PROG, conf[i].emailnewsgroup);
		system( prog );	//  
	}
	//    .
	remove( cctmp );	//   
	remove( LOCK );	//  lock - (  !)
	exit( 0 );
}

xcommentto(char *cctmp)
{
	int i = 0;
	char buf[MMAX+1];
	char tmp[MMAX+1];
	FILE *f;

	if( ( f = fopen( cctmp, "r" ) ) == NULL ) exit( 2 );
	while( i != RMAXCC )
	{
		while( fgets( buf, MMAX, f ) != NULL )
		{
			if( strlen( buf ) == MMAX ) exit( 4 );
			switch( conf[i].cc )
			{
			case 0:
				if(strncmp(buf,FROM,strlen(FROM))==0)
				{
				  if(strstr( buf, conf[i].name )!=0)
				  {
					  fclose( f );
					  log( i );
					  return( i );
				  }
				}
				break;
			case 1:
				if(strncmp(buf,TO0,strlen(TO0))==0||
			     	strncmp(buf,TO1,strlen(TO1))==0)
				{
				  if(strstr( buf, conf[i].name )!=0)
				  {
					fclose( f );
					log( i );
					return( i );
				  }
				}
				break;
			case 2:
				if(strncmp(buf,SUBJ,strlen(SUBJ))==0)
				{
				  if(strstr( buf, conf[i].name )!=0)
				  {
					fclose( f );
					log( i );
					return( i );
				  }
				}
				break;
			case 3:
				if(strstr( buf, conf[i].name )!=0)
				{
					fclose( f );
					log( i );
					return( i );
				}
				break;
			case 4:
				strlwr( buf );
				strcpy( tmp, conf[i].name );
				strlwr( tmp );
				if(strstr( buf, tmp )!=0)
				{
					fclose( f );
					log( i );
					return( i );
				}
				break;
			}
		}
		i++;
		rewind( f );	//   
	}
	fclose( f );	//  
	return( -1 );
}

readconf()
{
	int max=0;
	char buffer[MAX];
	FILE *f;

	if( ( f = fopen( CONFIG, "r" ) ) == NULL ) exit( 2 );
	while( fgets( buffer, MAX, f ) != NULL && max++ != MAXCC )
	{
		if( buffer[0] != '#' )
		{
			sscanf( buffer, "%u|%u|%[^|]|%[^|\n]",
			  &conf[RMAXCC].num, &conf[RMAXCC].cc,
			  &conf[RMAXCC].name, &conf[RMAXCC].emailnewsgroup );
			RMAXCC++;
		}
	}
	fclose( f );
}

number(int n)
{
	int num = 1;
	char path[MMAX+1];
	FILE *f;

	_creat();	//  lock -
	sprintf( path, "%s.%d", NUM, n );	// /path/.cc.status.<num>
	if( ( f = fopen( path, "r" ) ) != NULL )
	{
		fscanf( f, "%u", &num );	//  
		if( num == 0 )	num = 1;
		fclose( f );
	}
	if( ( f = fopen( path, "w" ) ) == NULL ) exit( 2 );
	if( num < 1 ) num = 1;	// secure
	fprintf( f, "%d", num+1 ); //    .  
	fclose( f );
	return( num );		//    .
}

//  lock - (    ).
_creat()
{
	FILE *f;

	//   lock -.   - .
	while( ( access( LOCK, F_OK ) ) == 0 ) sleep( 1 );
	//  lock -.
	if( ( f = fopen ( LOCK, "w" ) ) == NULL ) exit( 2 );
	fprintf( f, "%d", getpid() );	//   lock - PID 
	fclose( f );
}

//     e-mail
//     'Mail'
sendemail(char *cctmp, int num)
{
	char mail[MAX];

	//   e-mail .
	if( strlen( conf[num].emailnewsgroup ) > MAXEMAIL )
		errorlog( conf[num].emailnewsgroup );	// secure
	sprintf( mail, "%s %s < %s", MAIL, conf[num].emailnewsgroup, cctmp );
	system( mail );	//  e-mail.
}

// .
log(int num)
{
	char buffer[MAX];
	FILE *f;

	logtime( buffer );
	sprintf( buffer, "%s Carbon Copy: string \"%s\" -> \"%s\"\n",
		buffer, conf[num].name,	conf[num].emailnewsgroup );
	if( ( f = fopen ( LOG, "a" ) ) == NULL ) exit( 2 );
	fputs( buffer, f );
	fclose( f );
}

errorlog(char *buf)
{
#ifdef	WERROR
	char buffer[MAX];
	FILE *f;

	logtime( buffer );
	sprintf( buffer, "%s Config Error in - %s",
		buffer, buf );
	if( ( f = fopen ( LOG, "a" ) ) == NULL ) exit( 2 );
	fputs( buffer, f );
	fclose( f );
#endif
	exit( 3 );
}

//  .
logtime(char *buf)
{
	char buffer[MAX];
	time_t timv = time( 0 );
	struct tm *local_tm = localtime( &timv );

	strftime( buf, MAX, "%b %d %H:%M:%S", local_tm );
	sprintf( buf, "%s [%d]", buf, getpid() );
}

//     .
// (   !)
// TODO -    ! ;(
strlwr(char *c)
{
	setlocale(LC_CTYPE,"");
	while( *c )
	{
		*c = tolower( *c );
		++c;
	}
}
